
#include "algorthm.h"
#include "oplib.h" 


class GridGA : public Algorithm
{
public:
	GridGA(void);
	~GridGA(void);
	
	void InitialiseAlgorithm(void);
	void TidyUp(void); 	

	void StartUp(void);
	void Iteration(void);
	int EndConditions(void);
	void End(void) {};
	void ResetGA(void);

	void InitialisePools(char* path = 0);
	
	// used before pools are created to define pool and individual set-up
	long GetNumIndividuals(void);
	void SetNumIndividuals(long pool_size);
	Individual* GetPrototype(void);
	void SetPrototype(Individual*);	
		
protected:
	int _extraAttributes;

	Crossover* _crossover;
	Mutation* _mutation;
	Selection* _selection;
	Initialisation* _initialisation;
	Migration* _migration;

	long _num_individuals;
	Individual* _prototype;
	char _problem_type[15];
};
