// *******************************************************************************
// File name:		qgtypes.h
// Author:		Laura Dekker
// Description:
//
//
// Change history:      WBLangdon 5/12/94 change for GridGA
//
//
// *******************************************************************************
//#define DEBUG1 1

#ifndef _QGTYPES_H
#define _QGTYPES_H

#ifdef MS_WINDOWS
	#include <windows.h>
#endif

#define EMPTY				-1
#define INVALID_INDEX			-1 

#define TRUE				 1
#define FALSE				 0

#define MAX_FILE_PATH			255 

#define	MIN				  0
#define MAX				  1


enum GeneType
{
	G_ENCODED,
	G_INT,
	G_FLOAT,
	G_USER
};

class Gene;
class Chromosome;

#ifdef EXTERNAL_FITNESS
class _export Individual;
#else
class Individual;
#endif

class Pool;
#define MAX_POOLS			10
#define DEF_NUM_POOLS			 1 
#define DEF_POPULATION_SIZE		20
#define DEF_NUM_CHROMOSOMES		 1
#define	DEF_CHROMOSOME_LENGTH		 8
#define DEF_GENE_TYPE			G_INT

#define DEF_MAX_GEN			100

class OperatorLibrary;
class Operator;
class BaseOperator;

class Algorithm;

class Evaluator;
enum EvaluatorType { E_SCRIPT, E_SPREADSHEET, E_DLL };
class EvalDLL;
class EvalExcel;
class EvalScript;

enum OptimiseType { MINIMISE, MAXIMISE };


typedef double FitnessType;

#define MAX_PARAMS			 5
#define LABEL_LENGTH			50
#define MAX_OPERATORS			25

enum ParameterType
{
	P_BOOL,
	P_INT,
	P_LONG,
	P_FLOAT,
	P_STRING,
	P_FILENAME
};

enum OperatorType
{
	OP_SELECTION,
	OP_CROSSOVER,
	OP_MUTATION,
	OP_MIGRATION,
	OP_INITIALISE,
	OP_HILL_CLIMBER,
	OP_MISC
};
typedef int OperatorID;

#define DEF_PCROSS			0.6
#define DEF_PMUT			0.03
#define DEF_PMIG			0.3

#define DEF_TRUNCATION			0.5
#define DEF_LIN_CONST			2

#define DEF_ELITISM		   	TRUE
#define DEF_NORMALISING_SCALE		100000
#define DEF_GROUP_SIZE			2


// temporary limits
#define MAX_CHAR			0x7F
#define MAX_INT				0x7FFF
#define MAX_LONG			0x7FFFFFFF
#define MAX_ULONG			0xFFFFFFFF
#define MAX_DOUBLE			0x7FFFFFFF

#ifndef MS_WINDOWS
	#define BOOL int
#endif

#endif
