// *******************************************************************************
// File name:		rand.cpp
// Author:		Laura Dekker
// Description:		Random number generator and manipulator functions
//
//
// Change history: WBL 5/12/94 define RAND_MAX
//
//
// *******************************************************************************

#include <time.h>
#include <stdlib.h>
#include <assert.h>
#include "qgtypes.h"
#include "rand.h"
//this is range given in man pages. Should be defined in stdlib.h K+R
//#define RAND_MAX 32767
//doesnt work under SUN try
#define RAND_MAX 2147483647
#ifdef UNIX
#endif UNIX

double MinOrMax (BOOL min_or_max, double value, double min, double max)
{   											  
	return   min == max ? 1.0 :
			((min_or_max == MIN) ? 	(1.0+((value-max)/(min-max))) :		// minimising
									(1.0+((value-min)/(max-min))));		// maximising
}

/**************************************************************************
 Return 0 or 1, with a given bias
 **************************************************************************/

int Flip(float bias)
{
    double i=((double)rand())/RAND_MAX;

    assert(i<=1.0);

    if ((bias == 1.0) || (i < bias))
		return (TRUE);
    else
		return (FALSE);
}



/************************************************************************** 
 Random integer in range  min,max
 **************************************************************************/

int Int_Rand(int min, int max)
{
	int result;
	double real1 = ((double)rand())/RAND_MAX; // get value in range 0,1

	if (min == 0  &&  max == 1)
	{
		if (real1<=0.5)
			result = 0;
		else
			result = 1;
	}

	else
	{
		real1 = real1*(max-min);	// puts in range 0,max-min
		real1 = real1+min;		// puts in range min,max

                // round up or down
		result = (int)real1;
		double real2 = real1-result;
		if(real2 >= 0.5)
			result+=1;
	}
 
	return result;        
}
